-- hds header_start
--
-- VHDL Entity CALICE_seriface.seriface_ramtest.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 00:54:12 11/19/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity seriface_ramtest is
   generic( 
      RAMTEST_CLOCK_DIVIDER : integer := 10416
   );
   port( 
      clk        : in     std_logic;
      rst        : in     std_logic;
      serial_in  : in     std_logic;
      tp_i       : in     std_logic;
      activity_o : out    std_logic;
      debugbus   : out    std_logic_vector (7 downto 0);
      serial_out : out    std_logic;
      trigger_o  : out    std_logic
   );

-- Declarations

end seriface_ramtest ;

-- hds interface_end
--
-- VHDL Architecture CALICE_seriface.seriface_ramtest.struct_64k
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 00:54:12 11/19/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


library CALICE_seriface;

architecture struct_64k of seriface_ramtest is

   -- Architecture declarations

   -- Internal signal declarations
   signal addr      : std_logic_vector(15 downto 0);
   signal addr15_2  : std_logic_vector(13 downto 0);
   signal addr_strb : std_logic;
   signal db        : std_logic_vector(31 downto 0);
   signal db_rd     : std_logic;
   signal db_wr     : std_logic;
   signal ram_dout  : std_logic_VECTOR(31 downto 0);


   -- ModuleWare signal declarations for instance 'I3' of 'tap'
   signal MW_I3dinl : std_logic_vector(15 downto 0);

   -- Component Declarations
   component cg_ram16kx32
   port (
      addr  : in     std_logic_VECTOR (13 downto 0);
      clk   : in     std_logic ;
      din   : in     std_logic_VECTOR (31 downto 0);
      dout  : out    std_logic_VECTOR (31 downto 0);
      sinit : in     std_logic ;
      we    : in     std_logic 
   );
   end component;
   component seriface
   generic (
      CLOCK_DIVIDER : integer := 868
   );
   port (
      serial_in  : in     std_logic ;
      activity_o : out    std_logic ;
      serial_out : out    std_logic ;
      tp_i       : in     std_logic ;
      rst        : in     std_logic ;
      clk        : in     std_logic ;
      debugbus   : out    std_logic_vector (7 downto 0);
      addr       : out    std_logic_vector (15 downto 0);
      addr_strb  : out    std_logic ;
      db_rd      : out    std_logic ;
      db_wr      : out    std_logic ;
      db         : inout  std_logic_vector (31 downto 0);
      trigger_o  : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : cg_ram16kx32 use entity CALICE_seriface.cg_ram16kx32;
   for all : seriface use entity CALICE_seriface.seriface;
   -- pragma synthesis_on


begin

   -- ModuleWare code for instance 'I6' of 'tribuf'
   
   I6combo: process (ram_dout, db_rd)
   begin
      if (db_rd = '0' or db_rd = 'L') then
         db <= (others => 'Z');
      elsif (db_rd = '1' or db_rd = 'H') then
         db <= ram_dout;
      else
         db <= (others => 'X');
      end if;
   end process I6combo;

   -- ModuleWare code for instance 'I3' of 'tap'
   MW_I3dinl <= addr;
   addr15_2 <= MW_I3dinl(15 downto 2);
   -- Instance port mappings.
   I1 : cg_ram16kx32
      port map (
         addr  => addr15_2,
         clk   => clk,
         din   => db,
         dout  => ram_dout,
         sinit => rst,
         we    => db_wr
      );
   I0 : seriface
      generic map (
         CLOCK_DIVIDER => RAMTEST_CLOCK_DIVIDER
      )
      port map (
         serial_in  => serial_in,
         activity_o => activity_o,
         serial_out => serial_out,
         tp_i       => tp_i,
         rst        => rst,
         clk        => clk,
         debugbus   => debugbus,
         addr       => addr,
         addr_strb  => addr_strb,
         db_rd      => db_rd,
         db_wr      => db_wr,
         db         => db,
         trigger_o  => trigger_o
      );

end struct_64k;
