-- hds header_start
--
-- VHDL Entity CALICE_seriface.seriface.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 01:31:33 11/19/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity seriface is
   generic( 
      CLOCK_DIVIDER : integer := 868
   );
   port( 
      serial_in  : in     std_logic;
      activity_o : out    std_logic;
      serial_out : out    std_logic;
      tp_i       : in     std_logic;
      rst        : in     std_logic;
      clk        : in     std_logic;
      debugbus   : out    std_logic_vector (7 downto 0);
      addr       : out    std_logic_vector (15 downto 0);
      addr_strb  : out    std_logic;
      db_rd      : out    std_logic;
      db_wr      : out    std_logic;
      db         : inout  std_logic_vector (31 downto 0);
      trigger_o  : out    std_logic
   );

-- Declarations

end seriface ;

-- hds interface_end
--
-- VHDL Architecture CALICE_seriface.seriface.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 01:31:33 11/19/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library CALICE_seriface;

architecture struct of seriface is

   -- Architecture declarations

   -- Internal signal declarations
   signal tx_data       : std_logic_vector(7 downto 0);
   signal sdout_rdy     : std_logic;
   signal rx_data       : std_logic_vector(7 downto 0);
   signal rxrdy         : std_logic;
   signal delayed_txrdy : std_logic;
   signal txrdy         : std_logic;


   -- Component Declarations
   component const_count_delay
   generic (
      DELAYVAL : integer := 1023
   );
   port (
      clk         : in     std_logic ;
      rst         : in     std_logic ;
      sig         : in     std_logic ;
      delayed_sig : out    std_logic 
   );
   end component;
   component protocol
   port (
      clk         : in     std_logic ;
      rst         : in     std_logic ;
      sdata_in    : in     std_logic_vector (7 downto 0);
      sdin_wren   : in     std_logic ;
      addr_o      : out    std_logic_vector (15 downto 0);
      addr_strb_o : out    std_logic ;
      db_rd_o     : out    std_logic ;
      db_wr_o     : out    std_logic ;
      sdata_out   : out    std_logic_vector (7 downto 0);
      sdout_rdy   : out    std_logic ;
      db_io       : inout  std_logic_vector (31 downto 0);
      txrdy_i     : in     std_logic ;
      trigger_o   : out    std_logic 
   );
   end component;
   component ser_rx
   generic (
      clockdiv : integer := 10416
   );
   port (
      clk      : in     std_logic ;
      rst      : in     std_logic ;
      data_out : out    std_logic_vector (7 downto 0);
      rxd      : in     std_logic ;
      rxrdy    : out    std_logic 
   );
   end component;
   component ser_tx
   generic (
      clockdiv : integer := 10416
   );
   port (
      clk     : in     std_logic ;
      rst     : in     std_logic ;
      data_in : in     std_logic_vector (7 downto 0);
      wr_en   : in     std_logic ;
      txd     : out    std_logic ;
      txrdy   : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : const_count_delay use entity CALICE_seriface.const_count_delay;
   for all : protocol use entity CALICE_seriface.protocol;
   for all : ser_rx use entity CALICE_seriface.ser_rx;
   for all : ser_tx use entity CALICE_seriface.ser_tx;
   -- pragma synthesis_on


begin

   -- ModuleWare code for instance 'buff1' of 'buff'
   activity_o <= txrdy;
   -- Instance port mappings.
   const_count_delay1 : const_count_delay
      generic map (
         DELAYVAL => 1000
      )
      port map (
         clk         => clk,
         rst         => rst,
         sig         => txrdy,
         delayed_sig => delayed_txrdy
      );
   protocol1 : protocol
      port map (
         clk         => clk,
         rst         => rst,
         sdata_in    => rx_data,
         sdin_wren   => rxrdy,
         addr_o      => addr,
         addr_strb_o => addr_strb,
         db_rd_o     => db_rd,
         db_wr_o     => db_wr,
         sdata_out   => tx_data,
         sdout_rdy   => sdout_rdy,
         db_io       => db,
         txrdy_i     => delayed_txrdy,
         trigger_o   => trigger_o
      );
   ser_rx1 : ser_rx
      generic map (
         clockdiv => CLOCK_DIVIDER
      )
      port map (
         clk      => clk,
         rst      => rst,
         data_out => rx_data,
         rxd      => serial_in,
         rxrdy    => rxrdy
      );
   ser_tx1 : ser_tx
      generic map (
         clockdiv => CLOCK_DIVIDER
      )
      port map (
         clk     => clk,
         rst     => rst,
         data_in => tx_data,
         wr_en   => sdout_rdy,
         txd     => serial_out,
         txrdy   => txrdy
      );

end struct;
