-- hds header_start
--
-- VHDL Architecture CALICE_seriface.seriface_tester.untitled
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 16:46:15 11/03/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity seriface_tester is
   port( 
      activity_o : in     std_logic;
      addr       : in     std_logic_vector (15 downto 0);
      addr_strb  : in     std_logic;
      db_rd      : in     std_logic;
      db_wr      : in     std_logic;
      debugbus   : in     std_logic_vector (7 downto 0);
      serial_out : in     std_logic;
      trigger_o  : in     std_logic;
      clk        : out    std_logic;
      rst        : out    std_logic;
      serial_in  : out    std_logic;
      tp_i       : out    std_logic;
      db         : inout  std_logic_vector (31 downto 0)
   );

-- Declarations

end seriface_tester ;

-- hds interface_end
architecture test of seriface_tester is

	signal clk_osc : std_logic := '1';
	constant clkperiod : time :=  10 ns;
	
	constant ser_period : time := 10*870 ns;
	
	signal serdata : std_logic_vector(0 to 7);
	
begin

	-- clock generator
	-----------------------------------------------------------------------
	clk_osc <= not clk_osc after clkperiod / 2;
	clk <= clk_osc;
	


	-- Main Simulation
	----------------------------------------------------------------------
	simulation: process
		
	begin

	
	
	
	   serial_in  <= '1';
	   tp_i       <= '0';
	   
	   --db	<= "00000001000000100000001100000100";
	
		rst <= '1';
		wait for 20 ns;
		rst <= '0';
		wait for 5 ns;
		


		-----------------------------------------
		-- Commands
		-------------
		-- byte(0)     7  6  5       4       3  2  1  0
		--             OP-CODE   CMD/REPLY   DESTINATION
		--
		-- OP-CODE
		--   000	Test, Replies with Data = 0xA110A110 ('allo 'allo!!!)
		--   001 Write
		--   010 Read 1
		--	  011 Read 2
		--   100 Status

		serdata <= "00101000";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;
		
	
		wait for 5 ns;
	
		-----------------------------------------
		serdata <= "00100001";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;
	
		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "00110001";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;

		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "01000001";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;

		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "01010001";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;

		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "01100001";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;

		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "01110001";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;


		wait for ser_period*55;

		------------------------------------------

		-----------------------------------------
		-- Commands
		-------------
		-- byte(0)     7  6  5       4       3  2  1  0
		--             OP-CODE   CMD/REPLY   DESTINATION
		--
		-- OP-CODE
		--   000	Test, Replies with Data = 0xA110A110 ('allo 'allo!!!)
		--   001 Write
		--   010 Read 1
		--	  011 Read 2
		--   100 Status

		serdata <= "01001000";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;
		
	
		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "11111110";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;
	
		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------
	
		serdata <= "11111101";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;

		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "11111100";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;

		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "11111011";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;

		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "11111010";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;

		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "11111001";
		
		serial_in <= '0';
		wait for ser_period;
		
		for n in 0 to 7 loop
			serial_in <= serdata(7-n);
			wait for ser_period;
		end loop;
	
		serial_in <= '1';
		wait for ser_period;

		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------


		wait for ser_period*55;                   
                                                
		------------------------------------------
                                                
		-----------------------------------------
		-- Commands                               
		-------------                             
		-- byte(0)     7  6  5       4       3  2 
		--             OP-CODE   CMD/REPLY   DESTI
		--                                        
		-- OP-CODE                                
		--   000	Test, Replies with Data = 0xA110A
		--   001 Write                            
		--   010 Read 1                           
		--	  011 Read 2                           
		--   100 Status 
		--   111 Trigger 		                          
                                                
		serdata <= "11101000";                    
		                                          
		serial_in <= '0';                         
		wait for ser_period;                      
		                                          
		for n in 0 to 7 loop                      
			serial_in <= serdata(7-n);             
			wait for ser_period;                   
		end loop;                                 
	                                             
		serial_in <= '1';                         
		wait for ser_period;                      
	                                             
		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "11111110";                    
		                                          
		serial_in <= '0';                         
		wait for ser_period;                      
		                                          
		for n in 0 to 7 loop                      
			serial_in <= serdata(7-n);             
			wait for ser_period;                   
		end loop;                                 
	                                             
		serial_in <= '1';                         
		wait for ser_period;                      
	                                             
		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "11111101";                    
		                                          
		serial_in <= '0';                         
		wait for ser_period;                      
		                                          
		for n in 0 to 7 loop                      
			serial_in <= serdata(7-n);             
			wait for ser_period;                   
		end loop;                                 
	                                             
		serial_in <= '1';                         
		wait for ser_period;                      
                                                
		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "11111100";                    
		                                          
		serial_in <= '0';                         
		wait for ser_period;                      
		                                          
		for n in 0 to 7 loop                      
			serial_in <= serdata(7-n);             
			wait for ser_period;                   
		end loop;                                 
	                                             
		serial_in <= '1';                         
		wait for ser_period;                      

		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "11111011";                    
		                                          
		serial_in <= '0';                         
		wait for ser_period;                      
		                                          
		for n in 0 to 7 loop                      
			serial_in <= serdata(7-n);             
			wait for ser_period;                   
		end loop;                                 
	                                             
		serial_in <= '1';                         
		wait for ser_period;                      
                                                
		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "11111010";                    
		                                          
		serial_in <= '0';                         
		wait for ser_period;                      
		                                          
		for n in 0 to 7 loop                      
			serial_in <= serdata(7-n);             
			wait for ser_period;                   
		end loop;                                 
	                                             
		serial_in <= '1';                         
		wait for ser_period;                      
                                                
		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		serdata <= "11111001";                    
		                                          
		serial_in <= '0';                         
		wait for ser_period;                      
		                                          
		for n in 0 to 7 loop                      
			serial_in <= serdata(7-n);             
			wait for ser_period;                   
		end loop;                                 
	                                             
		serial_in <= '1';                         
		wait for ser_period;                      
                                                
		-----------------------------------------
		wait for 25 ns;                            
		-----------------------------------------

		
		wait;      
  	end process;  
                       
end test;        