-- hds header_start
--
-- VHDL Architecture CALICE_lib.seriface.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:42:27 10/28/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity wire_loopback is
   port( 
      clk        : in     std_logic;
      rst        : in     std_logic;
      serial_in  : in     std_logic;
      act_o      : out    std_logic;
      count_o    : out    std_logic_vector (3 downto 0);
      serial_out : out    std_logic;
      tp_i       : in     std_logic
   );

-- Declarations

end wire_loopback ;

-- hds interface_end
architecture rtl of wire_loopback is
	signal counter    	: std_logic_vector(19 downto 0);
	signal counter_en	 	: std_logic;
	signal startq   		: std_logic;
	signal startq2  		: std_logic;
	signal startq3  		: std_logic;
	
	signal byte_cntr    : std_logic_vector(3 downto 0);
	signal byte_cntr_en : std_logic;
	
	signal shiftreg	  : std_logic_vector(9 downto 0);
	
begin

-- loopback ------------------
--serial_out <= serial_in;
shiftreg(9) <= serial_in;
serial_out <= shiftreg(0);


-- shift register -------------------
shift_regsiter : process (clk)
begin
   if rising_edge(clk) then

--      if (rst = '1') then
--         shiftreg <= (others => '0');

--      else
      	shiftreg(8 downto 0) <= shiftreg(9 downto 1);
      	
--     	end if;
   end if;
end process;



-- counter -------------------
counter_control : process (clk)
begin
   if rising_edge(clk) then
   	
   	startq  <= serial_in or tp_i;
   	startq2 <= startq;
   	startq3 <= startq2;
   	
      if (rst = '1') then
         counter_en <= '0';

      elsif (counter = "11111111111111111111") then
         counter_en <= '0';
   
      elsif ((startq2 = '1') and (startq3 = '0')) or (counter_en = '1') then
         counter_en <= '1';

      end if;
   end if;
end process;

counter_20bit : process (clk)
begin
   if rising_edge(clk) then
 
      if (rst = '1') then
         counter <= (others => '0');
        
      elsif (counter_en = '1') then
         	counter <= counter + '1';
         
      end if;
   end if;
end process;


byte_counter : process (clk)
begin
   if rising_edge(clk) then
		-- default   
  		byte_cntr_en <= '0';
   	if (startq2 = '1') and (startq3 = '0') then
   		byte_cntr_en <= '1';
 	
   	end if;
   		
  		-------------------------------------------
      if (rst = '1') then
         byte_cntr <= (others => '0');
        
      elsif (byte_cntr_en = '1') then
         	byte_cntr <= byte_cntr + '1';
         
      end if;
      
   end if;
end process;




-----------------------------------------------------
act_o <= counter_en;
count_o <= shiftreg(4 downto 1);



end rtl;
