import sys
import serial

def ProtoTest(desti, cmdi, addri, datai):
    ser=serial.Serial(0, 115200, timeout=1)

    #print ser.BAUDRATES
    # Available Baudrates
    # 50, 75, 110, 134, 150, 200, 300, 600, 1200, 1800, 2400, 4800
    # 9600, 19200, 38400, 57600, 115200
   

    print "--------------------------------------------------"

    print "Name     ", ser.portstr
    print "Port     ", ser.port
    print "Baudrate ", ser.baudrate
    print "ByteSize ", ser.bytesize
    print "Parity   ", ser.parity
    print "Stopbits ", ser.stopbits
    print "Xon/Xoff ", ser.xonxoff
    print "---------------------\n"

    import time
    print "Time: ",time.time(),"\n"
  
    dest   = string2num(desti)
    cmd    = string2num(cmdi)
    addr16 = string2num(addri)
    data32 = string2num(datai)

    a1, a0 = divmod(addr16, 0x100)

    d32, d10 = divmod(data32, 0x10000)
    d3, d2 = divmod(d32, 0x100)
    d1, d0 = divmod(d10, 0x100)

    #print "a1 :", hex(a1)
    #print "a0 :", hex(a0)
    #print "d3 :", hex(d3)
    #print "d2 :", hex(d2)
    #print "d1 :", hex(d1)
    #print "d0 :", hex(d0)
    
    ser.write( chr(dest)+chr(cmd)+chr(a0)+chr(a1)+chr(d0)+chr(d1)+chr(d2)+chr(d3) )

    #test write brocken msg to test timeout mechanism
    #ser.write( chr(dest)+chr(cmd) )
    
    print "\nTX: ",hex(dest), hex(cmd), hex( (a1*0x100)+ a0), hex( (d3*0x1000000)+(d2*0x10000)+(d1*0x100)+ d0 )

    destin = 0xFF
    cmdin  = 0xFF
    ain1   = 0xFF
    ain0   = 0xFF
    din3   = 0xFF
    din2   = 0xFF
    din1   = 0xFF
    din0   = 0xFF

    timeout = 1
    import time
    t = time.time()

    while time.time() < (t+0.1):
        if (ser.inWaiting() > 7):
            timeout = 0
                        
            destin = ord(ser.read())
            cmdin  = ord(ser.read())
            ain0   = ord(ser.read())
            ain1   = ord(ser.read())
            din0   = ord(ser.read())
            din1   = ord(ser.read())
            din2   = ord(ser.read())
            din3   = ord(ser.read())
        #end if
    #end while

    ain_val = (ain1*0x100)+ ain0
    din_val = (din3*0x1000000)+(din2*0x10000)+(din1*0x100)+ din0

    if (timeout == 1) :
        inwait = ser.inWaiting()
        print "TIMEOUT! RX buffer size = ",inwait
        for n in range(inwait):
            print "  data byte ",n," ", hex(ord(ser.read()))
            
    else :
        print "RX: ", hex(destin),"",hex(cmdin),"",hex(ain_val),"",hex(din_val)
        
      

    if (addr16 <> ain_val):
        print "Addr Match FAILED"
        print "Sent: ", hex( (a1*0x100)+ a0)
        print "Read: ", hex( ain_val)

    if (cmd == 0x02) :
        if (data32 <> din_val):
            print "Data Match FAILED (on write)"
            print "Sent: ", hex( (d3*0x1000000)+(d2*0x10000)+(d1*0x100)+ d0 )
            print "Read: ", hex( din_val )
       
    ser.flushInput()
    ser.flushOutput()
    ser.close()
    print "\nSerial port flushed and closed.\n"
    
    

    
    return

#---------------------------------------------------------------------------
#---------------------------------------------------------------------------

import sys

def string2num(number):
    try:
        a = long(number)
    except ValueError:
        try:
            a = long(number, 16) 
        except ValueError:
            print number," is not a number or a hex number!"
            sys.exit()
    return a

#--------------------------------------------------------------------------------

if __name__ == "__main__":
    print "------ Command Line Version ------"
    print "File: ", sys.argv[0]
    print "Dest: ", sys.argv[1]
    print "Cmd:  ", sys.argv[2]
    print "Addr: ", sys.argv[3]
    print "Data: ", sys.argv[4]

    
    ProtoTest( sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4] )





