import sys
import serial


#---------------------------------------------------------------------------
def RamTest(loops):

    iLoops = string2num(loops)
    
    ser=serial.Serial(0, 115200, timeout=1)

    print "---------------------------------------------------------------"

    print "Name     ", ser.portstr, ", Port     ", ser.port, ", Baudrate ", ser.baudrate, "."
    print "---------------------------------------------------------------\n"

    import time
    print "Time: ", time.time(),"\n"

    import random    

    a = {}
    d = {}
    
    for n in range(iLoops):

        a[n]    = int(random.uniform(0, 1023))*4
        d[a[n]] = int(random.uniform(0, 4294967279))

        (u, v, w, x) = RxTx(0x00, 0x02, a[n], d[a[n]], ser)

    #----------------------------------------------------------------
    errors = 0
    for n in range(iLoops):
        
        (dst, cmd, addr, data) = RxTx(0x00, 0x04, a[n], 0, ser)
        if (data <> d[a[n]]):
            print "MISMATCH: Addr: ", hex(a[n]),"   Wrote ",hex(d[n]),",  Read ",hex(data),"."
            errors = errors + 1
    
    print "\nTime: ", time.time()
    print "Errors ", errors
        
    ser.flushInput()
    ser.flushOutput()
    ser.close()
    print "\nSerial port flushed and closed.\n"
    
        
    return

#---------------------------------------------------------------------------

def RxTx(desti, cmdi, addri, datai, ser):

    debug = 0

    dest   = string2num(desti)
    cmd    = string2num(cmdi)
    addr16 = string2num(addri)
    data32 = string2num(datai)

       
    a1, a0 = divmod(addr16, 256)

    d32, d10 = divmod(data32, 0x10000)
    d3, d2 = divmod(d32, 0x100)
    d1, d0 = divmod(d10, 0x100)

    ser.write(chr(dest)+chr(cmd)+chr(a0)+chr(a1)+chr(d0)+chr(d1)+chr(d2)+chr(d3) )

    if (debug > 0):    
        print "\nTX: ",hex(dest), hex(cmd), hex( (a1*0x100)+ a0), hex( (d3*0x1000000)+(d2*0x10000)+(d1*0x100)+ d0 )
  

    destin  = 255
    cmdin   = 255    
    addrin1 = 255
    addrin0 = 255
    datain3 = 255
    datain2 = 255
    datain1 = 255
    datain0 = 255

    
    import time
    

    while (ser.inWaiting() < 8):
        timeout = 0;

    destin  = ord(ser.read())            
    cmdin   = ord(ser.read())
    addrin0 = ord(ser.read())
    addrin1 = ord(ser.read())
    datain0 = ord(ser.read())
    datain1 = ord(ser.read())
    datain2 = ord(ser.read())
    datain3 = ord(ser.read())

    addrin_val = (addrin1*0x100)+ addrin0
    datain_val = (datain3*0x1000000)+(datain2*0x10000)+(datain1*0x100)+ datain0

    if (addr16 <> addrin_val):
        print "Addr Match FAILED:  Sent ",hex(addr16),"  Read ",hex(addrin_val)

    if (cmd <> 0x02) : # write
        if (data32 == datain_val):
            print "Data Match FAILED (on write):  Sent ",hex(data32),"  Read ",hex(datain_val)    

    if (debug > 0):
        print "RX: ", hex(destin),"",hex(cmdin),"",hex(addrin_val),"",hex(datain_val)

        
    return (destin, cmdin, addrin_val, datain_val)

#---------------------------------------------------------------------------

import sys

def string2num(number):
    try:
        a = long(number)
    except ValueError:
        try:
            a = long(number, 16) 
        except ValueError:
            print number," is not a number or a hex number!"
            sys.exit()
    return a

#--------------------------------------------------------------------------------

if __name__ == "__main__":
    print "------ Command Line Version ------"
    print "sys.argv[0]", sys.argv[0]
    print "sys.argv[1]", sys.argv[1]
    #print "sys.argv[2]", sys.argv[2]
    #print "sys.argv[3]", sys.argv[3]
    #print "sys.argv[4]", sys.argv[4]
    
    RamTest(sys.argv[1])    





