-- hds header_start
--
-- VHDL Architecture CALICE_seriface.seriface_tester1.test
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:58:18 11/07/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity seriface_ram_tester is
   port( 
      activity_o : in     std_logic;
      debugbus   : in     std_logic_vector (7 downto 0);
      serial_out : in     std_logic;
      trigger_o  : in     std_logic;
      clk        : out    std_logic;
      rst        : out    std_logic;
      serial_in  : out    std_logic;
      tp_i       : out    std_logic
   );

-- Declarations

end seriface_ram_tester ;

-- hds interface_end
architecture test of seriface_ram_tester is

	signal clk_osc : std_logic := '1';
	constant clkperiod : time :=  10 ns;
	
	constant ser_period : time := 10*870 ns;
	
	signal serdata : std_logic_vector(0 to 7);
	
	constant CMD_TEST   : std_logic_vector(7 downto 0) := "00000000";
	constant CMD_WRITE  : std_logic_vector(7 downto 0) := "00000010";
	constant CMD_READ	  : std_logic_vector(7 downto 0) := "00000100";
	constant CMD_READRO : std_logic_vector(7 downto 0) := "00000110";
	constant CMD_STAT	  : std_logic_vector(7 downto 0) := "00001000";
	constant CMD_TRIG	  : std_logic_vector(7 downto 0) := "00010000";
					
		
begin

	-- clock generator
	-----------------------------------------------------------------------
	clk_osc <= not clk_osc after clkperiod / 2;
	clk <= clk_osc;
	

	-- Main Simulation
	----------------------------------------------------------------------
	simulation: process

		procedure Send_Serial(ssdata : in std_logic_vector(7 downto 0)) is
		begin
			serial_in <= '0';
			wait for ser_period;
		
			for n in 0 to 7 loop
				serial_in <= ssdata(n);
				wait for ser_period;
			end loop;
	
			serial_in <= '1';
			wait for ser_period;
		
			wait for 25 ns;
		
		end procedure; 
		
		--------------------------
		
		procedure Send_Message (
				idest : in integer range 0 to 255;	
				cmd   : in std_logic_vector( 7 downto 0); --integer range 0 to 255;
				iaddr : in integer range 0 to 65535;
				idata : in integer-- range 0 to 4294967295 -- 32 bit
			) is
			
			variable dest : std_logic_vector( 7 downto 0);
			variable addr : std_logic_vector(15 downto 0);
			variable data : std_logic_vector(31 downto 0);
			
		begin
		

			dest := conv_std_logic_vector(idest,  8);
			addr := conv_std_logic_vector(iaddr, 16);
			data := conv_std_logic_vector(idata, 32);
			
			Send_Serial(dest);
			Send_Serial(cmd);
			Send_Serial(addr( 7 downto 0));
			Send_Serial(addr(15 downto 8));
			Send_Serial(data( 7 downto  0));			
			Send_Serial(data(15 downto  8));
			Send_Serial(data(23 downto 16));
			Send_Serial(data(31 downto 24));
			
			wait for ser_period*100;
			
		end procedure; 
		
		--------------------------
		

		
	begin

	
	
	   serial_in  <= '1';
	   tp_i       <= '0';
	   
	   --db	<= "00000001000000100000001100000100";
	
		rst <= '1';
		wait for 20 ns;
		rst <= '0';
		wait for 5 ns;
		
		
		

		Send_Message(0, CMD_TEST,  16#0A0B#, 0);
		
		-- Test Timeout Counter -- Send "Broken" Message
		Send_Serial("00000000");
		Send_Serial("00000010");
		wait for ser_period*100;
		
		Send_Message(0, CMD_WRITE, 16#0004#, 16#12345678#);		
		Send_Message(0, CMD_WRITE, 16#1234#, 16#AABBCCDD#);				
		Send_Message(0, CMD_READ,  16#0004#, 0);		
		Send_Message(0, CMD_READ,  16#1234#, 0);				
		Send_Message(0, CMD_TRIG,  16#0000#, 0);				
	
		
		wait;      
  	end process;  
end test;
